#!/usr/bin/perl

@replace = (
    ["x264_pixel_sad_" => "x264_pixel_sad_*_mmx"],
    ["x264_pixel_ssd_" => "x264_pixel_ssd_*_mmx"],
    ["_satd_" => "x264_pixel_satd_*_mmx"],
    ["_sa8d_" => "x264_pixel_sa8d_*_mmx"],
    ["x264_pixel_avg_" => "x264_pixel_avg_*_mmx"],
    ["x264_pixel_avg2_" => "x264_pixel_avg2_*_mmx"],
    ["x264_mc_copy_" => "x264_mc_copy_*_mmx"],
    ["_trellis" => "quant_trellis_cabac"],
    ["_quant" => "x264_quant_*_mmx"],
    ["_dequant" => "x264_dequant_*_mmx"],
    ["idct" => "x264_idct_*_mmx"],
    ["dct" => "x264_dct_*_mmx"],
    ["deblock.*_c\$" => "x264_deblock_*_c"],
    ["deblock.*[^w]\$" => "x264_deblock_*_mmx"],
    ["^predict_" => "x264_predict_intra_*"],
    ["x264_mb_predict_mv.*" => "x264_mb_predict_mv_*"],
    ["x264_mb_mc" => "x264_mb_mc_*"],
    ["zigzag_scan_" => "zigzag_scan_*"],
    ["x264_mb_analyse_inter" => "x264_mb_analyse_inter_*"],
    ["x264_mb_analyse_intra" => "x264_mb_analyse_intra_*"],
    ["x264_mb_analyse_.*rd\$" => "x264_mb_analyse_*_rd"],
    ["x264_intra_rd\$" => "x264_mb_analyse_*_rd"],
    ["x264_mb_encode_i[0-9]" => "x264_mb_encode_i*"],
    ["x264_mb_cache_mv" => "x264_mb_cache_mv_*"],
    ["cabac_size_decision" => "cabac_size_decision*"],
);

while(<>) {
    my @F = split /\s+/, $_;
    next if @F != 3 or $F[0] =~ /[^0-9]/ or $F[1] =~ /[^0-9e.-]/;
    my $n = $F[2];

    foreach $k (0..$#replace) {
        if($n =~ $replace[$k][0]) {
            $n = $replace[$k][1];
            last;
        }
    }

    $n =~ s/mmxext/mmx/;
    $n =~ s/^x264_//;

    $dat{$n}[0] += $F[0];
    $dat{$n}[1] += $F[1];
}
for(sort { $dat{$b}[0] <=> $dat{$a}[0] } keys %dat) {
    printf "%-8d %7.4f  %s\n", $dat{$_}[0], $dat{$_}[1], $_ if $dat{$_}[1] >= .01;
}
